%% the 65 images have size 96x84 
X = preprocessing(96,84);

P = './yaleB01_outlier/';
D = dir(fullfile(P,'*.jpg'));
Xo = [];
for i = 1:size(D,1)
    Xi = imread(fullfile(P,D(i).name));
    Xi = imresize(Xi,[96 84]);
    Xo(:,i) = double(Xi(:))/255;
end


gam = .1; Ni = size(X,2);
No = floor(gam*Ni/(1-gam));
X = [X Xo(:,1:No)];
% p = randperm(size(X,2)); X = X(:,p);

llam = 9/( 7*sqrt(gam*size(X,2)) );
mu = size(X,1)*size(X,2)/(4*norm(X(:),1));

[L,E,Lam] = ADMM_OPP(X,llam,mu);
vE = vecnorm(E);

clf;
plot(1:Ni, vE(1:Ni),'b');
hold on;
plot(Ni+1:Ni+No, vE(Ni+1:Ni+No),'r');

% E_est = [];
% for i = 1:65
%     E_est(:,:,i) = reshape(E(:,i),96,84);
%     L_est(:,:,i) = reshape(L(:,i),96,84);
% end
% clf;
% colormap(gray(100))
% N = 10; i = 1;
% for k = [3 4 14 18 20 24 32 43 46 50]
%     subplot(3,N,i)
%     imagesc(reshape(X(:,k),96,84))
%     subplot(3,N,i+N)
%     imagesc(reshape(L(:,k),96,84))
%     subplot(3,N,i+2*N)
%     imagesc(reshape(E(:,k),96,84))
%     i = i+1;
% end
